"use strict";

this.name        = "galdrive_worldscript";
this.copyright   = "(C) 2024, Wildeblood";
this.description = "A function that needs to be shared.";
this.version     = "1.3";

/* ====================================================================================
	RESTORING THE CO-ORDINATES, OR RESETTING THE MISSION TEXT, AT START-UP
======================================================================================= */

    this.startUp = function () {
        "use strict";
        if (player.ship.equipmentStatus("EQ_GAL_DRIVE") !== "EQUIPMENT_OK") {
            delete missionVariables.galDrive_Coords;
            mission.setInstructions(null, this.name);
            player.ship.galacticHyperspaceBehaviour = "BEHAVIOUR_STANDARD";
            return;
        }
        if (missionVariables.galDrive_Coords) {
            player.ship.galacticHyperspaceBehaviour = "BEHAVIOUR_FIXED_COORDINATES";
            player.ship.galacticHyperspaceFixedCoordsInLY = Vector3D([JSON.parse(missionVariables.galDrive_Coords).x, JSON.parse(missionVariables.galDrive_Coords).y, JSON.parse(missionVariables.galDrive_Coords).z]);
        } else {
            mission.setInstructions(null, this.name);
        }
     // delete this.startUp;
    }

/* ====================================================================================
			EQUIPMENT SCRIPTS CALL THIS WHEN ACTIVATED

        Equipment scripts call this ***AFTER*** setting the new co-ordinates.
        worldScripts.galdrive_worldscript._saveDestination(destinationName);
======================================================================================= */

    this._saveDestination = function (destinationName) {
        "use strict";
        if (!destinationName) {
            delete missionVariables.galDrive_Coords;
            mission.setInstructions(null, this.name);
            return;
        }
        missionVariables.galDrive_Coords = JSON.stringify(player.ship.galacticHyperspaceFixedCoordsInLY);
        player.commsMessage("Co-ordinates: " + player.ship.galacticHyperspaceFixedCoordsInLY, 6);
        player.commsMessage("Destination: " + destinationName, 6);
        mission.setInstructions("Galactic™ hyperdrive destination is set to " + destinationName + ".", this.name);
    }

/* ====================================================================================
			PERFORMING A GALACTIC JUMP
======================================================================================= */

    this.playerEnteredNewGalaxy = function () {
        "use strict";
        mission.setInstructions(null, this.name);
        delete missionVariables.galDrive_Coords;
    }

/* ====================================================================================
			THE END
======================================================================================= */
